#include <windows.h>
#include <GL\gl.h>
#include <GL\glu.h>
#include <GL\glut.h>
#include "Resource.h"
#include "MyGL.h"

HWND hwnd;
MSG msg;
WNDCLASS wc;
HDC dc;
HGLRC hrc;
MyGL GL;

HRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInnstance, LPSTR lpCmdLine, int nShowCmd)
{
	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
	wc.hbrBackground=(HBRUSH)COLOR_BTNSHADOW;
	wc.hCursor=LoadCursor(0, IDC_ARROW);
	wc.hIcon=LoadIcon(0, IDI_APPLICATION);
	wc.hInstance=hInstance;
	wc.lpfnWndProc=WndProc;
	wc.lpszClassName="MyWindow";
	wc.lpszMenuName=(LPSTR)MAKEINTRESOURCE(IDR_MENU1);
	wc.style=CS_CLASSDC;
	RegisterClass(&wc);
	hwnd=CreateWindow("MyWindow", "3D-", WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, 0, 0, hInstance, NULL);
	ShowWindow(hwnd, SW_SHOW);
	UpdateWindow(hwnd);
	while (GetMessage(&msg, 0, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return 0;
}

HRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	case WM_CREATE:
		SetTimer(hwnd, 1000, 1, NULL);
		GL.GLInit(&hwnd, &hrc);
		return 0;
	case WM_SIZE:
		GL.ReSizeScene(LOWORD(lParam), HIWORD(lParam));
		return 0;
	case WM_TIMER:
		GL.RenderScene(&hwnd);
        return 0;

	default: return DefWindowProc(hwnd, msg, wParam, lParam);
	}
}

